/*
 * xzx    : Copyright (c) Des Herriott 1993, 1994
 * xcoupe : Copyright (c) Allan Skillman 1995.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Allan Skillman
 *  
 */

/* Source file debug.c - A primative Z80 debugger. */

#include <stdio.h>

#include "z80.h"
#include "debug.h"

void help_message(void);
char waitforchar(void);

int 
run_debug(uns16 ThePC)
{		
		int TheChar;
		char sbuf[100];

		static int FirstTime = 1;
			
		if (FirstTime) {
			printf("XCoupe Z80 debugger, type h for help\n\n");
			FirstTime = !FirstTime;
		}	
			
			
		disassemble(sbuf, ThePC);
		printf("%s\t\t\t\t",sbuf);
		TheChar = waitforchar();
		switch (TheChar) {
			case 'd':
				printf("\n");
/*				dump_cpu_state();*/
				return(2);
				break;
			case 'r':
				printf("Returning to Emulation mode\n\n");
				fflush(stdout);
				return(0);
				break;
			case 'z':
				{ 
				 uns16 pc_tmp;
				 printf("Disassembly, type z to return\n");
				 printf("address (in Hex) : ");
				 scanf("%x",&pc_tmp);
				 do { 
				   pc_tmp = (uns16)disassemble(sbuf,pc_tmp);
				   printf("Disassembly : %s\t\t\t\t",sbuf);
				 } while (waitforchar() !='z');
				}
				break;
			case 'h' :
				help_message();
				break;	
			default:
				break;
		} /* End case */									        			

		return(1);
}

void 
help_message()
{
	printf("\n");
	printf("XCoupe Z80 debugger - (c) 1996 A.J.Skillman\n");
	printf("-------------------------------------------\n");
	printf("\nCommands :\n\t\td : Register Dump\n"
			     "\t\th : Show this help\n"
			     "\t\tr : Exit Debugger\n"
			     "\t\tz : Show Disassembly\n\n");
	printf("-------------------------------------------\n\n");
			    
}

char
waitforchar()
{
	char tmp[255];
	char *res;		

	fflush(stdin);
	return ((res = gets(tmp)) != NULL ? *res : 0);
}

