/*
 * Copyright (c) Des Herriott 1993, 1994
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Des Herriott
 */

/*
 * Source file edops.c - operation prefixed by 0xED.
 */

/* in_b__c_ */
case 0x40:
	*b = in_byte(*bc);
	do_input_flags(*b);
	break;

/* out__c__b */
case 0x41:
	out_byte(*bc, *b);
	break;

/* sbc_hl_bc */
case 0x42:
	subtract_and_test16(*bc, Tst(carryFlag) ? 1 : 0);
	break;

/* ld (NN), bc */
case 0x43:
	work16 = GetNext2Ops;
	write_word(work16,*bc);
	break;

/* neg */
case 0x44:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* retn */
case 0x45:
	pc = PopValue;
	theProcessor.iff1 = theProcessor.iff2;
	break;

/* im_0 */
case 0x46:
	theProcessor.im = 0;
	break;

/* ld_i_a */
case 0x47:
	int_vec = *a;
	break;

/* in_c__c_ */
case 0x48:
	*c = in_byte(*bc);
	do_input_flags(*c);
	break;

/* out__c__c */
case 0x49:
	out_byte(*bc, *c);
	break;

/* adc_hl_bc */
case 0x4A:
	add_and_test16(*bc, Tst(carryFlag)? 1 : 0);
	break;

/* ld bc,(NN) */
case 0x4B:
	work16 = GetNext2Ops;
	*bc = read_word(work16);
	break;

/* neg - undocumented (ajs) */
case 0x4C:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* for our purposes, this is equivalent to ret */
/* reti */
case 0x4D:
	pc = PopValue;
	break;

/* ld_r_a */
case 0x4F:
	refresh = *a;
	break;

/* in_d__c_ */
case 0x50:
	*d = in_byte(*bc);
	do_input_flags(*d);
	break;

/* out__c__d */
case 0x51:
	out_byte(*bc, *d);
	break;

/* sbc_hl_de */
case 0x52:
	subtract_and_test16(*de, Tst(carryFlag) ? 1 : 0);
	break;

/* ld__NN__de */
case 0x53:
	work16 = GetNext2Ops;
	write_word(work16, *de);
	break;

/* neg - undocumented (ajs) */
case 0x54:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* ret - undocumented (ajs) */
case 0x55:
	pc = PopValue;
	break;

/* im_1 */
case 0x56:
	theProcessor.im = 1;
	break;

/* ld_a_i */
case 0x57:
	*a = int_vec;
	par_overFlag = theProcessor.iff2;
	signFlag = (*a & 0x80);
	zeroFlag = !(*a);
	break;

/* in_e__c_ */
case 0x58:
	*e = in_byte(*bc);
	do_input_flags(*e);
	break;

/* out__c__e */
case 0x59:
	out_byte(*bc, *e);
	break;

/* adc_hl_de */
case 0x5A:
	add_and_test16(*de, Tst(carryFlag)? 1 : 0);
	break;

/* ld_de__NN_ */
case 0x5B:
	work16 = GetNext2Ops;
	*de = read_word(work16);
	break;

/* neg - undocumented (ajs) */
case 0x5C:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* ret - undocumented (ajs) */
case 0x5D:
	pc = PopValue;
	break;

/* im_2 */
case 0x5E:
	theProcessor.im = 2;
	break;

/* ld_a_r */
case 0x5F:
	refresh = instrs & 0x7f;
	*a = refresh;
	par_overFlag = theProcessor.iff2;
	signFlag = (*a & 0x80);
	zeroFlag = !(*a);
	break;

/* in_h__c_ */
case 0x60:
	*h = in_byte(*bc);
	do_input_flags(*h);
	break;

/* out__c__h */
case 0x61:
	out_byte(*bc, *h);
	break;

/* sbc_hl_hl */
case 0x62:
	subtract_and_test16(*hl, Tst(carryFlag) ? 1 : 0);
	break;

/* ld__nn__hl */
case 0x63:
	work16 = GetNext2Ops;
	write_word(work16, *hl);
	break;


/* neg - undocumented (ajs) */
case 0x64:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* ret - undocumented (ajs) */
case 0x65:
	pc = PopValue;
	break;

/* im_0 - undocumented (ajs) */
case 0x66:
	theProcessor.im = 0;
	break;

/* rrd */
case 0x67:
	work8 = read_byte(*hl);
	work8_2 = (work8 >> 4) | ((*a & 0x0f) << 4);
	*a = (*a & 0xf0) | (work8 & 0x0f);
	signFlag = *a & 0x80;
	zeroFlag = !(*a);
	par_overFlag = parity_tbl[*a];
	write_byte(*hl,work8_2);
	break;

/* in_l__c_ */
case 0x68:
	*l = in_byte(*bc);
	do_input_flags(*l);
	break;

/* out__c__l */
case 0x69:
	out_byte(*bc, *l);
	break;

/* adc_hl_hl */
case 0x6A:
	add_and_test16(*hl, Tst(carryFlag)? 1 : 0);
	break;

/* ld_hl__NN_ also defined in z80ops.c */
case 0x6B:
	work16 = GetNext2Ops;
	*hl = read_word(work16);
	break;

/* neg - undocumented (ajs) */
case 0x6C:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* ret - undocumented (ajs) */
case 0x6D:
	pc = PopValue;
	break;

/* rld */
case 0x6F:
	work8 = read_byte(*hl);
	work8_2 = ((work8 <<4) | (*a & 0x0f)) & 0xff;
	*a = (*a & 0xf0) | (work8 >> 4);
	signFlag = *a & 0x80;
	zeroFlag = !(*a);
	par_overFlag = parity_tbl[*a];
	write_byte(*hl, work8_2);
	break;

/* in_f__c_ */
case 0x70:
	*f = in_byte(*bc);
	do_input_flags(*f);
	RetrieveFlags();
	break;

/* out (c),0 - undocumented (ajs) */
case 0x71:
	out_byte(*bc, 0);
	break;

/* sbc_hl_sp */
case 0x72:
	subtract_and_test16(sp, Tst(carryFlag) ? 1 : 0);
	break;

/* ld__NN__sp */
case 0x73:
	work16 = GetNext2Ops;
	write_word(work16, sp);
	break;

/* neg - undocumented (ajs) */
case 0x74:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* ret - undocumented (ajs) */
case 0x75:
	pc = PopValue;
	break;

/* im_1  - undocumened (ajs) */
case 0x76:
	theProcessor.im = 1;
	break;

/* in_a__c_ */
case 0x78:
	*a = in_byte(*bc);
	do_input_flags(*a);
	break;

/* out__c__a */
case 0x79:
	out_byte(*bc, *a);
	break;

/* adc_hl_sp */
case 0x7A:
	add_and_test16(sp, Tst(carryFlag)? 1 : 0);
	break;

/* ld_sp__NN_ */
case 0x7B:
	work16 = GetNext2Ops;
	sp = read_byte(work16) + (read_byte(work16 + 1) << 8);
	break;

/* neg - undocumented (ajs) */
case 0x7C:
	work8 = *a;
	*a = 0;
	subtract_and_test(work8, 0);
	break;

/* ret - undocumented (ajs) */
case 0x7D:
	pc = PopValue;
	break;

/* im_2 - undocumented (ajs) */
case 0x7E:
	theProcessor.im = 2;
	break;

/* ldi */
case 0xA0:
	write_byte(*de,read_byte(*hl));
	(*de)++; (*hl)++; (*bc)--;
	par_overFlag = *bc; Clr(hcarryFlag); Clr(addsubFlag);
	break;

/* cpi */
case 0xA1:
	compare_and_test(read_byte(*hl));
	(*hl)++; (*bc)--;
	par_overFlag = *bc;
	break;

/* ini */
case 0xA2:
	write_byte(*hl, in_byte(*bc));
	(*b)--; (*hl)++;
	zeroFlag = !(*b);
	Set(addsubFlag);
	break;

/* outi */
case 0xA3:
	(*b)--;
	out_byte(*bc, read_byte(*hl));
	(*hl)++;
	zeroFlag = !(*b);
	Set(addsubFlag);
	break;

/* ldd */
case 0xA8:
	write_byte(*de,read_byte(*hl));
	(*de)--; (*hl)--; (*bc)--;
	par_overFlag = *bc; Clr(hcarryFlag); Clr(addsubFlag);
	break;

/* cpd */
case 0xA9:
	compare_and_test(read_byte(*hl));
	(*hl)--; (*bc)--;
	par_overFlag = *bc;
	break;

/* ind */
case 0xAA:
	write_byte(*hl, in_byte(*bc));
	(*b)--; (*hl)--;
	zeroFlag = !(*b);
	Set(addsubFlag);
	break;

/* outd */
case 0xAB:
	(*b)--;
	out_byte(*bc, read_byte(*hl));
	(*hl)--;
	zeroFlag = !(*b);
	Set(addsubFlag);
	break;

/* ldir */
case 0xB0:
	do {
		write_byte(*de,read_byte(*hl));
		(*hl)++; (*de)++; (*bc)--;
	} while (*bc);

	Clr(hcarryFlag); Clr(par_overFlag); Clr(addsubFlag);
	break;

/* cpir */
case 0xB1:
	do {
		compare_and_test(read_byte(*hl));
		(*hl)++; (*bc)--;
		par_overFlag = *bc;
	} while (*bc && !zeroFlag);
	break;

/* inir */
case 0xB2:
	do {
		write_byte(*hl, in_byte(*bc));
		(*b)--; (*hl)++;
	} while (*b);

	Set(zeroFlag); Set (addsubFlag);
	break;

/* otir */
case 0xB3:
	do {
		(*b)--;
		out_byte(*bc, read_byte(*hl));
		(*hl)++;
	} while (*b);

	Set(zeroFlag); Set(addsubFlag);
	break;

/* lddr */
case 0xB8:
	do {
		write_byte(*de,read_byte(*hl));
		(*hl)--; (*de)--; (*bc)--;
	} while (*bc);

	Clr(hcarryFlag); Clr(par_overFlag); Clr(addsubFlag);
	break;

/* cpdr */
case 0xB9:
	do {
		compare_and_test(read_byte(*hl));
		(*hl)--; (*bc)--;
		par_overFlag = *bc;
	} while (*bc && !zeroFlag);
	break;

/* indr */
case 0xBA:
	do {
		write_byte(*hl, in_byte(*bc));
		(*b)--; (*hl)--;
	} while (*b);

	Set(zeroFlag); Set (addsubFlag);
	break;

/* otdr */
case 0xBB:
	do {
		(*b)--;
		out_byte(*bc, read_byte(*hl));
		(*hl)--;
	} while (*b);

	Set(zeroFlag); Set(addsubFlag);
	break;


/*
 * Now some pseudo-ops with special meaning to xcoupe
 */

/* debug trap */
case 0x00:
	xcoupe_mesg(XCOUPE_INFO, "ED 00 - processor trap");
/*	dump_cpu_state();*/
	fprintf(stderr, "  <q> to quit, any other key to continue: ");
	do {
		work8 = getchar();
		if (work8 == 'q' || work8 == 'Q') Quit(0);
	} while (work8 == 0xff);
	break;

#ifdef XBELL_AUDIO
/* Trap the ROM and ring the server bell */
case 0xFA:
	if (GetCfg(bell_vol)) {
		int f, t;

		f = 1750000 / ((*hl + 30) << 2);
		t = (1000 * *de) / f;
		ring_bell(f, (int)t);
#ifdef DEBUG
		xcoupe_mesg(XCOUPE_INFO, "BEEP: freq = %d Hz, time = %d ms", f, (int)t);
#endif
	}
	break;
#endif


/* Unimplemented */
default:
	xcoupe_mesg(XCOUPE_ERR, "unimplemented instruction ED %02X",
		read_byte(((uns16)pc - 1)));
	break;

